#! /bin/sh

#
# here documents have to be indented by tabs, if you expect the 
# indentation to be removed by cat <<-EOF
#

ascutfcat ()
{
    [ $km -gt 16 ] &&
         cat | sed 's//ö/g;s//Ö/g;s//ü/g;s//Ü/g;s//ä/g;s//Ä/g;s//ß/g'
    cat
}

if [ -n "$2" ]
then
  param2=$2
else
  param2=''
fi

km=`cat /etc/kernel-minor`
clrhome
case $1 in

    info)
        ascutfcat <<-EOF
		fli4l - Installation auf Festplatte / Compact-Flash
		
		Installationswunsch abfragen
		
		Bitte drcken Sie einfach Return, um mit der Installation auf die 
		vorgeschlagene Festplatte fortzufahren. 
		Sie knnen alternativ die Bezeichnung einer anderen Festplatte 
		eingeben, wobei die folgende Tabelle gilt:
		
		  primrer IDE Controller,   Master   hda
		  primrer IDE Controller,   Slave    hdb
		  sekundrer IDE Controller, Master   hdc
		  sekundrer IDE Controller, Slave    hdd
		  erste (S)ATA/SCSI-Festplatte        sda
		
		Um die Installation an dieser Stelle abzubrechen geben Sie X ein.
EOF
        ;;

    inv_partition_table)
        ascutfcat <<-EOF
		fli4l - Installation auf Festplatte / Compact-Flash

		Die Partitionstabelle ist in einem inkonsistenten Zustand.
		Um eine ordnungsgemsse Installation sicherzustellen, muss im
		ersten Schritt eine gltige Partitionstabelle geschrieben werden.
		Dabei gehen alle Informationen auf der Platte verloren.
		
		Soll die Partitionstabelle jetzt neu geschrieben werden?
		
		***************************************************************
		* Dies ist Ihre letzte Chance vor dem drohenden Datenverlust! *
		*   Alle Daten auf der Festplatte werden hiermit gelscht!    *
		***************************************************************
		
		Bitte geben Sie JA in Grobuchstaben ein, um weiterzumachen: 
EOF
        ;;
    installation_type)
        ascutfcat <<-EOF
		fli4l - Installation auf Festplatte / Compact-Flash
		
		Installationstyp auswhlen
		 
		Typ A: Betrieb komplett aus der Ramdisk
		    Alle bentigten Dateien werden auf einer DOS-Partition abgelegt. Beim Start
		    des Routers wird alles in eine Ramdisk entpackt und von dort aus gestartet.
		    Die Festplatte wird nur als greres Diskettenlaufwerk benutzt. Falls keine
		    Daten-Partition genutzt wird, kann der Router auch ohne Shutdown 
		    abgeschaltet werden.
		
		Typ B: Auslagerung der sekundren Ramdisk auf die Festplatte
		    Die Dateien aus dem opt.img werden automatisch auf eine ext3-Partition
		    entpackt und von dort gestartet. Dies bringt Vorteile bei einem Router mit
		    sehr wenig RAM (8-12MB), kann aber Probleme mit dem Abschalten einer 
		    IDE-Platte mit OPT_HDSLEEP verursachen. Ein sauberer Shutdown vor dem 
		    Abschalten des Routers ist unbedingt notwendig.
		
		
		Bitte whlen Sie: A oder B (X bricht die Installation ab)
EOF
        ;;

    dos_partition)
        if [ -z "$param2" ]
        then
          param2=2
        fi
        ascutfcat <<-EOF
		fli4l - Installation auf Festplatte / Compact-Flash
		  
		DOS-Partition anlegen
		   
		Wie gro soll die DOS-Partition werden?
		
		Die Mindestgre ist $param2 MB, empfohlen werden 4 bis 8 MB.
		Die maximale Gre ist 128 MB, hhere Werte werden automatisch auf 128 MB
		verkleinert! Tippen Sie 1 ein, wenn Sie den gesamten Speicherplatz eines 
		Mediums mit weniger als 128 MB fr die DOS-Partition nutzen wollen. 
		
		Bitte geben Sie die gewnschte Gre in MB ein, 1 fr die maximale 
		Partitionsgre bzw. den Rest der Platte oder X fr exit: 
EOF
        ;;

    opt_partition)
        ascutfcat <<-EOF
		fli4l - Installation auf Festplatte / Compact-Flash
		
		Opt-Partition anlegen
		
		Wie gro soll die Partition fr das entpackte opt.img werden?
		
		Die Mindestgre sind 2 MB, empfohlen werden 4 bis 16 MB. Maximal mglich 
		sind hier 512 MB. Diese Partition wird anstelle der sekundren Ramdisk 
		genutzt. Bitte berlegen Sie nochmals ob der Installationstyp A ihre 
		Anforderungen nicht ebenfalls erfllt.
		 
		Bitte geben Sie die gewnschte Gre in MB ein, 1 fr den Rest der 
		Platte bzw. die maximale Partitionsgre oder X fr exit: 
EOF
        ;;

    swap_partition)
        ascutfcat <<-EOF
		fli4l - Installation auf Festplatte / Compact-Flash
		 
		Swap-Partition anlegen
		 
		Mchten Sie eine Swap-Partition anlegen?
		
		Dies ist normalerweise nur notwendig, wenn sie wenig Hauptspeicher zur
		Verfgung haben. Die Swap-Partition sollte mindestens so gro wie der real 
		eingebaute Hauptspeicher (RAM) sein. Die maximale Gre sind 256 MB, Werte 
		darber werden automatisch auf 256 MB verringert.
		
		Eine Swap-Partition ist nur bei Verwendung einer Festplatte sinnvoll. Wenn
		Sie fli4l auf ein Flash-Medium installieren, sollten Sie kein Swap anlegen, 
		weil Sie sonst einen frhzeitigen Defekt des Mediums riskieren!
		
		Bitte geben Sie die gewnschte Gre in MB ein, 1 fr die maximale Gre bzw.
		den Rest der Platte oder drcken Sie einfach Enter, wenn Sie keine 
		Swap-Partition anlegen wollen:
EOF
        ;;

    data_partition)
        ascutfcat <<-EOF
		fli4l - Installation auf Festplatte / Compact-Flash
		 
		Daten-Partition anlegen
		 
		Mchten Sie eine zustzliche Daten-Partition anlegen?
		
		Dies ist nur notwendig, wenn Sie auf dem Router etwas Platz fr Dateiablage
		z.B. fr opt_vbox oder opt_samba_lpd bentigen.
		Es wird hierfr eine ext3-Partition angelegt.
		Die maximale Gre ist 2 TB, grssere Werte werden automatisch verkleinert!
		
		Bitte geben Sie die gewnschte Gre in MB ein, 1 fr die maximale Gre bzw.
		den Rest der Platte oder drcken Sie einfach Enter, wenn Sie keine 
		Daten-Partition anlegen wollen: 
EOF
        ;;

    final_warning)
        ascutfcat <<-EOF
		fli4l - Installation auf Festplatte / Compact-Flash
		 
		Sicherheitsabfrage vor der Neupartitionierung
		
		***************************************************************
		* Dies ist Ihre letzte Chance vor dem drohenden Datenverlust! *
		*   Alle Daten auf der Festplatte werden hiermit gelscht!    *
		***************************************************************
		
		Bitte geben Sie JA in Grobuchstaben ein, um die Platte wie 
		folgt zu partitionieren:
EOF
        ;;

    final_warning_1)
	ascutfcat <<-EOF
		fli4l - Installation auf Festplatte / Compact-Flash
		
		Sicherheitsabfrage vor der Neupartitionierung
		
		Bitte geben Sie JA in Grobuchstaben ein, um die Platte wie 
		folgt zu partitionieren:
EOF
	;;

    standard_saving_failed)
        ascutfcat <<-EOF
		fli4l - Installation auf Festplatte / Compact-Flash
		
		Der Versuch, die Standard-Bootdateien zu sichern, schlug fehl.
		Nach einer Neupartitionierung muss eine aktuelle Version mittels
		remote update auf den Router kopiert werden.
		
		Bitte geben Sie JA in Grobuchstaben ein, um fortzufahren:

EOF
	;;

    recovery_saving_failed)
        ascutfcat <<-EOF
		fli4l - Installation auf Festplatte / Compact-Flash
		
		Der Versuch, die Recovery-Bootdateien zu sichern, schlug fehl.
		Nach einer Neupartitionierung muss die Recovery-Version neu erstellt
		werden.
		
		Bitte geben Sie JA in Grobuchstaben ein, um fortzufahren:

EOF
	;;
    finish)
        ascutfcat <<-EOF
		fli4l - Installation auf Festplatte / Compact-Flash
		 
		Wie geht es weiter?
		  
		Die Festplatte wurde partitioniert, formatiert und ist jetzt unter /boot
		erreichbar. Sie knnen jetzt alle gewnschten Opt-Pakete aktivieren und 
		per imonc, fli4l-Build oder scp auf den Router nach /boot bertragen.
		
		Der Router bentigt folgende Dateien um von der Festplatte zu starten:
		syslinux.cfg, kernel, rootfs.img, rc.cfg und opt.img
		
		WICHTIG: Sie mssen die aufgefhrten Dateien jetzt per remote update
		auf den Router bertragen, andernfalls ist der Router nicht in der
		Lage, von HD zu booten!
		
		Entfernen Sie nach dem remote update die Diskette aus dem Router, 
		fahren Sie ihn herunter (unter Verwendung von halt/reboot/poweroff)
		und starten Sie neu.
		Drcken Sie nicht einfach nur Reset, dabei knnen die beim
		Remote-Update vorgenommenen nderungen verloren gehen.
		
EOF
        ;;
    finish_repartitioning)
        ascutfcat <<-EOF
		fli4l - Installation auf Festplatte / Compact-Flash
		 
		Wie geht es weiter?
		  
		Die Festplatte wurde neu partitioniert und formatiert, der Router kann 
		jetzt neu gebootet werden. 
		
		Wollen Sie neben der Neupartitionierung auch gleich Updates am Router
		vornehmen, koennen Sie das jetzt per remote update tun.
		
		Fahren Sie dann den Router herunter (unter Verwendung
		von halt/reboot/poweroff) und starten Sie neu.
		Drcken Sie nicht einfach nur Reset, dabei knnen die
		beim Remote-Update bzw. bei der Re-Partitionierung
		vorgenommenen nderungen verloren gehen.
		
EOF
        ;;
    *)
        echo "Unknown text message requested, please inform author."
	exit 1
	;;
esac
exit 0
