#! /bin/sh

#
# here documents have to be indented by tabs, if you expect the 
# indentation to be removed by cat <<-EOF
#

if [ -n "$2" ]
then
  param2=$2
else
  param2=''
fi

ascutfcat ()
{
    [ $km -gt 16 ] &&
         cat | sed 's//î/g;s//é/g;s//è/g;s//à/g;s//ê/g;s//ô/g;s//û/g;s//â/g'
    cat
}


km=`cat /etc/kernel-minor`
clrhome
case $1 in

    info)
        ascutfcat <<-EOF
		fli4l - Installation d'un disque dur / Compact-Flash

		Choisir le disque dur

		Appuyez sur entre pour confirmer l'installation du disque dur propos,
		vous pouvez aussi enregistrer un autre type de disque valide.

		Pour l'installation d'un autre disque dur, entrer l'un des paramtres
		suivants.
		  Primaire IDE, matre       :   hda
		  Primaire IDE, esclave      :   hdb
		  Secondaire IDE, matre     :   hdc
		  Secondaire IDE, esclave    :   hdd
		  Premier disque (S)ATA/SCSI :   sda

		Indiquez un nouveau paramtre ou appuyez sur X pour sortir du programme:
EOF
        ;;

    inv_partition_table)
        ascutfcat <<-EOF
		fli4l - Installation d'un disque dur / Compact-Flash

		La table de partition est dans un tat instable. Pour assurer une
		bonne installation, vous devez crire une table de partition valide
		sur votre disque avant de continuer l'installation. L'criture
		d'une nouvelle table de partition va dtruire toutes les donnes 
		sur votre disque.

		Voulez-vous rcrire la table de partition maintenant ?

		*****************************************************************
		* C'est votre dernire chance avant la perte de vos donnes !   *
		* Toutes les donnes sur votre disque dur SERONT SUPPRIMEES de  *
		* manire irrversible !                                        *
		*****************************************************************

		Entrez OUI en majuscule pour continuer:
EOF
        ;;

    installation_type)
        ascutfcat <<-EOF
		fli4l - Installation d'un disque dur / Compact-Flash

		Choisir le type d'installation

		Type A: tous les fichiers ncessaires sont stocks sur une partition
		DOS. Au dmarrage, tout est extrait et install dans la mmoire RAM
		et tous les programmes fonctionneront sur la mmoire RAM du routeur.
		Le disque dur est seulement utilis comme une disquette de grande capacit.

		Type B: utilise une partition ext3 en plus de la mmoire RAM.
		Les fichiers d'installation "boot" sont stocks sur la partition DOS.
		Les programmes inclus dans opt.img sont dcompresss automatiquement
		et installs sur la partition ext3, ils seront dmarrs sur cette partition.
		L'avantage de ce systme, c'est qu'il utilise trs peu de mmoire RAM.

		Choisissez S.V.P. le type d'installation, entrez A ou B en majuscule ou
		appuyez sur X pour sortir du programme:
EOF
        ;;

    dos_partition)
        if [ -z "$param2" ]
        then
          param2=2
        fi
        ascutfcat <<-EOF
		fli4l - Installation d'un disque dur / Compact-Flash

		Cration de la partition DOS

		Taille de la partition DOS ?

		La taille minimale est de $param2 mga-octets, la taille recommande est
		entre 4 et 8 mga-octets. La taille maximale est de 128 mga-octets, si
		vous augmentez la taille elle sera rduite automatiquement  128 mga-octets
		sur votre disque dur ou Compact-Flash.

		Vous pouvez crire la taille dsire en mga-octets ou appuyez sur 1
		pour utiliser la taille maximale de la partition ou sur X pour sortir
		du programme:
EOF
        ;;

    opt_partition)
        ascutfcat <<-EOF
		fli4l - Installation d'un disque dur / Compact-Flash

		Cration de la partition OPT

		Taille de la partition pour la dcompression de l'opt.img ?

		La taille minimale est de 2 mga-octets, la taille recommande est entre
		4 et 16 mga-octets. La taille maximale est de 512 mga-octets, si vous
		augmentez la taille elle sera rduite automatiquement  512 mga-octets
		sur votre disque dur ou Compact-Flash.

		Vous pouvez crire la taille dsire en mga-octets ou appuyez sur 1
		pour utiliser la taille maximale de la partition ou sur X pour sortir
		du programme:
EOF
        ;;

    swap_partition)
        ascutfcat <<-EOF
		fli4l - Installation d'un disque dur / Compact-Flash

		Cration de la partition SWAP

		Voulez-vous crer une partition swap ?

		En gnral la partition swap n'est pas ncessaire, vous devez la crer
		seulement si vous avez peu de mmoire RAM disponible. La partition swap
		doit tre au moins gale  la mmoire RAM installe sur le routeur.
		La taille maximale est de 256 mga-octets, si vous augmentez la taille
		elle sera rduite automatiquement  256 mga-octets sur votre disque dur.

		Vous devrez crer une partition swap uniquement sur un disque dur.
		Si vous utilisez un Compact-Flash, vous ne devez pas crer de
		partition swap !

		Vous pouvez crire la taille dsire en mga-octets ou appuyez sur 1 pour
		utiliser la taille maximale de la partition ou appuyez sur entre si vous
		ne voulez pas crer de partition swap ou sur X pour sortir du programme:
EOF
        ;;

    data_partition)
        ascutfcat <<-EOF
		fli4l - Installation d'un disque dur / Compact-Flash

		Cration de la partition DATA

		Voulez-vous crer une partition supplmentaire ?

		Seulement ncessaire si vous utilisez un ou plusieurs programmes sur votre
		routeur pour stocker des fichiers, par exemple opt_vbox ou opt_samba_lpd.
		Alors, une partition ext3 peut tre cre. La taille maximale est de
		2 tra-octets, si vous augmentez la taille elle sera rduite automatiquement
		 2 tra-octets sur votre disque dur.

		Vous pouvez crire la taille dsire en mga-octets ou appuyez sur 1 pour
		utiliser la taille maximale de la partition ou appuyez sur entre si vous
		ne voulez pas crer de partition data ou sur X pour sortir du programme:
EOF
        ;;

    final_warning)
        ascutfcat <<-EOF
		fli4l - Installation d'un disque dur / Compact-Flash

		Dernire tape avant le partitionnement

		*****************************************************************
		* C'est votre dernire chance avant la perte de vos donnes !   *
		* Toutes les donnes sur votre disque dur SERONT SUPPRIMEES de  *
		* manire irrversible !                                        *
		*****************************************************************

		S'il vous plat entrez OUI en majuscule pour crer les partitions dfinies
		ou sur X pour sortir du programme:
EOF
        ;;

    final_warning_1)
        ascutfcat <<-EOF
		fli4l - Installation d'un disque dur / Compact-Flash

		Contrle de scurit avant le partitionnement

		S'il vous plat entrez OUI en majuscule pour crer les partitions dfinies:
EOF
        ;;

    recovery_saving_failed)
        ascutfcat <<-EOF
		fli4l - Installation d'un disque dur / Compact-Flash

		Impossible d'installer la version de secours "recovery". Vous devez
		partitionner  nouveau votre disque pour installer la version de secours.

		S'il vous plat entrez OUI en majuscule pour continuer:
EOF
        ;;

    standard_saving_failed)
        ascutfcat <<-EOF
		fli4l - Installation d'un disque dur / Compact-Flash

		Impossible d'installation des fichiers de boot par dfaut. Vous devez
		partitionner  nouveau votre disque pour installer la version des fichiers
		de boot sur le routeur.

		S'il vous plat entrez OUI en majuscule pour continuer:
EOF
        ;;

    finish)
        ascutfcat <<-EOF
		fli4l - Installation d'un disque dur / Compact-Flash

		Que dois-je faire ensuite ?

		Le disque dur a t partitionn et format, il est maintenant accessible
		depuis le /boot. Vous pouvez modifier la configuration selon vos besoins
		en utilisant les paquetages Opt et transfrez les fichiers crs avec Imonc
		ou avec fli4l-Build ou avec SCP dans le /boot du disque dur.

		Les archives suivantes sont ncessaires pour initialiser le disque dur:
		syslinux.cfg, kernel, rootfs.img, opt.img et rc.cfg

		ATTENTION: vous devez transfrer les fichiers mentionns ci-dessus sur
		le routeur (avant de le redmarrer), autrement le routeur ne pourra pas
		booter sur le disque dur !

		Aprs une nouvelle mise  jour  distance ou par disquette, retirez
		la disquette de votre routeur et redmarrez le routeur avec l'une des
		commandes suivantes reboot/halt/poweroff. Ne pas simplement redmarrer
		votre routeur avec le bouton reset, autrement, les dernires modifications
		ne seront pas prises en compte.
EOF
        ;;

    finish_repartitioning)
        ascutfcat <<-EOF
		fli4l - Installation d'un disque dur / Compact-Flash

		Que dois-je faire ensuite ?

		Le disque dur a t  nouveau partitionn et format, vous pouvez
		redmarrer votre routeur.

		Vous pouvez aussi mettre  jour le routeur avec l'option remote uptade
		du fli4l-Build si vous le souhaitez.

		Vous devez ensuite redmarrer le routeur avec l'une des commandes
		suivantes reboot/halt/poweroff. Ne vous contentez pas d'appuyer sur
		le bouton reset de votre routeur, autrement, les dernires modifications
		ne seront pas prises en compte.
EOF
        ;;
    *)
        echo "Unknown text message requested, please inform author."
	exit 1
        ;;
esac
exit 0
